import { memo } from 'react';
import { jsx, Fragment } from 'react/jsx-runtime';

function For(_ref) {
  var each = _ref.each,
    fallback = _ref.fallback,
    children = _ref.children;
  if (each === undefined || each === null || each.length === 0) {
    return fallback != null ? fallback : null;
  }
  return each.map(children);
}

var TypedMemo = memo;

var ForMemo = TypedMemo(For);

function ForIf(_ref) {
  var each = _ref.each,
    when = _ref.when,
    fallback = _ref.fallback,
    children = _ref.children;
  return jsx(For, {
    each: each == null ? void 0 : each.filter(when),
    fallback: fallback,
    children: children
  });
}

var ForIfMemo = TypedMemo(ForIf);

function Show(_ref) {
  var when = _ref.when,
    fallback = _ref.fallback,
    children = _ref.children;
  if (when !== undefined && when !== null && when === true) {
    return children;
  }
  return fallback != null ? fallback : null;
}

function Hide(_ref) {
  var when = _ref.when,
    fallback = _ref.fallback,
    children = _ref.children;
  return jsx(Show, {
    when: when === false || when === undefined || when === null,
    fallback: fallback,
    children: children
  });
}

function Switch(_ref) {
  var fallback = _ref.fallback,
    children = _ref.children;
  var showFallback = function showFallback() {
    if (!Array.isArray(children)) {
      return children.props.when === undefined || children.props.when === null || !children.props.when;
    }
    return children.every(function (child) {
      return child.props.when === undefined || child.props.when === null || !child.props.when;
    });
  };
  if (showFallback()) {
    return fallback != null ? fallback : null;
  }
  return jsx(Fragment, {
    children: children
  });
}
function Match(_ref2) {
  var when = _ref2.when,
    children = _ref2.children;
  return jsx(Show, {
    when: when,
    children: children
  });
}

export { For, ForIf, ForIfMemo, ForMemo, Hide, Match, Show, Switch };
//# sourceMappingURL=index.esm.js.map
